with Ada.Text_IO;
use Ada.Text_IO;

with ITI8590.Partitions.IO;
use ITI8590.Partitions.IO;

procedure ITI8590.Partitions.Test is
   Data : Partition := Singletons(1, 4);

   procedure Unite_And_Log(Item_1, Item_2 : in Element) is
   begin
      Put("Uniting partitions of ");
      Put(Item_1);
      Put(" and ");
      Put(Item_2);
      New_Line;
      Unite(Data, Item_1, Item_2);
   end Unite_And_Log;

   procedure Output_Part(Item : in Element) is
   begin
      Put(Item);
      Put(" in ");
      Put(Part(Data, Item));
      New_Line;
   end Output_Part;
begin
   Output_Part(2);
   Unite_And_Log(1, 2);
   Output_Part(1);
   Output_Part(2);
   Unite_And_Log(3, 4);
   Output_Part(3);
   Output_Part(4);
   Unite_And_Log(1, 4);
   for Item in Element range 1 .. 4 loop
      Output_Part(Item);
   end loop;
end ITI8590.Partitions.Test;
