package body ITI8590.Partitions is

   function Singletons(Minimum, Maximum : in Element) return Partition is
      Data : Partition := new Nodes(Minimum .. Maximum);
   begin
      for Item in Minimum .. Maximum loop
         Data(Item) := (Parent => Item, Rank => 0);
      end loop;
      return Data;
   end Singletons;

   procedure Unite(Data : in out Partition; Item_1, Item_2 : in Element) is
   begin
      Link(Data, Part(Data, Item_1), Part(Data, Item_2));
   end Unite;

end ITI8590.Partitions;
